import airouter
import re
from airouter.models import LLM

def replace_header(original_table, new_header):
    original_header = re.search(r'<thead>(.*?)</thead>', table, re.DOTALL)
    span = original_header.span()
    new_table = original_table[:span[0]] + new_header + original_table[span[1]:]
    return new_table

table = '<table border="1" class="dataframe">\n  <thead>\n    <tr style="text-align: right;">\n      <th>Unnamed: 0_level_0 Unnamed: 0_level_1</th>\n      <th>Year Ended December 31, 2022</th>\n      <th>Year Ended December 31, 2021</th>\n      <th>Year Ended December 31, 2020</th>\n      <th>$ Change % Change 2021 to 2022</th>\n      <th>$ Change % Change 2021 to 2022.1</th>\n      <th>$ Change 2020 to 2021</th>\n      <th>% Change 2020 to 2021</th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>($ millions)</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n    </tr>\n    <tr>\n      <td>Revenues:</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n    </tr>\n    <tr>\n      <td>Product</td>\n      <td>$ 527</td>\n      <td>$ 678</td>\n      <td>$ 633</td>\n      <td>$ (151)</td>\n      <td>(22)%</td>\n      <td>$ 45</td>\n      <td>7 %</td>\n    </tr>\n    <tr>\n      <td>Service</td>\n      <td>1078</td>\n      <td>1092</td>\n      <td>1090</td>\n      <td>(14)</td>\n      <td>(1)</td>\n      <td>2</td>\n      <td>0</td>\n    </tr>\n    <tr>\n      <td>Total revenues</td>\n      <td>$ ,605</td>\n      <td>$ 1,770</td>\n      <td>$ 1,723</td>\n      <td>$ (165)</td>\n      <td>(9)%</td>\n      <td>$ 47</td>\n      <td>3 %</td>\n    </tr>\n    <tr>\n      <td>Costs and expenses:</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n    </tr>\n    <tr>\n      <td>Product costs, excluding depreciation and amortization</td>\n      <td>531</td>\n      <td>601</td>\n      <td>615</td>\n      <td>(70)</td>\n      <td>(12)</td>\n      <td>(14)</td>\n      <td>(2)</td>\n    </tr>\n    <tr>\n      <td>Service costs, excluding depreciation and amortization</td>\n      <td>393</td>\n      <td>383</td>\n      <td>378</td>\n      <td>10</td>\n      <td>3</td>\n      <td>5</td>\n      <td>1</td>\n    </tr>\n    <tr>\n      <td>Selling, general and administrative</td>\n      <td>431</td>\n      <td>369</td>\n      <td>332</td>\n      <td>62</td>\n      <td>17</td>\n      <td>37</td>\n      <td>11</td>\n    </tr>\n    <tr>\n      <td>Depreciation and amortization</td>\n      <td>239</td>\n      <td>290</td>\n      <td>348</td>\n      <td>(51)</td>\n      <td>(18)</td>\n      <td>(58)</td>\n      <td>(17)</td>\n    </tr>\n    <tr>\n      <td>(Gain) loss on orbital receivables allowance</td>\n      <td>-</td>\n      <td>(49)</td>\n      <td>14</td>\n      <td>49</td>\n      <td>(100)</td>\n      <td>(63)</td>\n      <td>*</td>\n    </tr>\n    <tr>\n      <td>Impairment loss</td>\n      <td>-</td>\n      <td>-</td>\n      <td>33</td>\n      <td>--</td>\n      <td>*</td>\n      <td>(33)</td>\n      <td>(100)</td>\n    </tr>\n    <tr>\n      <td>Loss on sale of assets</td>\n      <td>--</td>\n      <td>--</td>\n      <td>1</td>\n      <td>--</td>\n      <td>*</td>\n      <td>(1)</td>\n      <td>(100)</td>\n    </tr>\n    <tr>\n      <td>Operating income</td>\n      <td>$ 11</td>\n      <td>$ 176</td>\n      <td>$ 2</td>\n      <td>$ (165)</td>\n      <td>(94)%$</td>\n      <td>174</td>\n      <td>* 0%</td>\n    </tr>\n    <tr>\n      <td>Interest expense, net</td>\n      <td>158</td>\n      <td>151</td>\n      <td>175</td>\n      <td>7</td>\n      <td>5</td>\n      <td>(24)</td>\n      <td>(14)</td>\n    </tr>\n    <tr>\n      <td>Other expense (income), net</td>\n      <td>1</td>\n      <td>(8)</td>\n      <td>(104)</td>\n      <td>9</td>\n      <td>(113)</td>\n      <td>96</td>\n      <td>(92)</td>\n    </tr>\n    <tr>\n      <td>(Loss) income before taxes</td>\n      <td>$ (148)</td>\n      <td>$ 33</td>\n      <td>$ (69) :selected:</td>\n      <td>$ (181)</td>\n      <td>* %</td>\n      <td>$ 102</td>\n      <td>(148)%</td>\n    </tr>\n    <tr>\n      <td>Income tax expense (benefit)</td>\n      <td>2</td>\n      <td>(13)</td>\n      <td>(22)</td>\n      <td>15</td>\n      <td>(115)</td>\n      <td>9</td>\n      <td>(41)</td>\n    </tr>\n    <tr>\n      <td>Equity in income from joint ventures, net of tax</td>\n      <td>-</td>\n      <td>--</td>\n      <td>(1)</td>\n      <td>-</td>\n      <td>*</td>\n      <td>1</td>\n      <td>(100)</td>\n    </tr>\n    <tr>\n      <td>(Loss) income from continuing operations</td>\n      <td>$ (150) :selected:</td>\n      <td>$ 46</td>\n      <td>$ (46) :selected:</td>\n      <td>$ (196)</td>\n      <td>* %</td>\n      <td>$ 92</td>\n      <td>(200)%</td>\n    </tr>\n    <tr>\n      <td>Discontinued operations:</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n    </tr>\n    <tr>\n      <td>Income from operations of discontinued operations, net of tax</td>\n      <td>--</td>\n      <td>--</td>\n      <td>32</td>\n      <td>--</td>\n      <td>*</td>\n      <td>(32)</td>\n      <td>(100)</td>\n    </tr>\n    <tr>\n      <td>Gain on disposal of discontinued operations, net of tax</td>\n      <td>-</td>\n      <td>--</td>\n      <td>317</td>\n      <td>--</td>\n      <td>*</td>\n      <td>(317)</td>\n      <td>(100</td>\n    </tr>\n    <tr>\n      <td>Income from discontinued operations, net of tax</td>\n      <td>--</td>\n      <td>--</td>\n      <td>349</td>\n      <td>-</td>\n      <td>-X-</td>\n      <td>(349)</td>\n      <td>(100)</td>\n    </tr>\n    <tr>\n      <td>Net (loss) income</td>\n      <td>$ (150)</td>\n      <td>$ 46</td>\n      <td>$ 303</td>\n      <td>$ (196)</td>\n      <td>*</td>\n      <td>(257)</td>\n      <td>(85)%</td>\n    </tr>\n  </tbody>\n</table>'
table = '<table border="1" class="dataframe">\n  <thead>\n    <tr style="text-align: right;">\n      <th>Unnamed: 0_level_0 Unnamed: 0_level_1</th>\n      <th>Year Ended December 31, 2022</th>\n      <th>Year Ended December 31, 2021</th>\n      <th>Year Ended December 31, 2020</th>\n      <th>$ Change 2021</th>\n      <th>% Change to 2022</th>\n      <th>$ Change 2020 to 2021</th>\n      <th>% Change 2020 to 2021</th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>($ millions)</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n    </tr>\n    <tr>\n      <td>Product revenues</td>\n      <td>$ 527</td>\n      <td>$ 678</td>\n      <td>$ 633</td>\n      <td>$ (151)</td>\n      <td>(22)%$</td>\n      <td>45.0</td>\n      <td>7 %</td>\n    </tr>\n    <tr>\n      <td>Service revenues</td>\n      <td>1078</td>\n      <td>1092</td>\n      <td>1090</td>\n      <td>(14)</td>\n      <td>(1)</td>\n      <td>2.0</td>\n      <td>0</td>\n    </tr>\n    <tr>\n      <td>Total revenues</td>\n      <td>$ 1,605</td>\n      <td>$ 1,770</td>\n      <td>$ 1,723</td>\n      <td>$ (165)</td>\n      <td>(9)%$</td>\n      <td>47.0</td>\n      <td>3 %</td>\n    </tr>\n  </tbody>\n</table>'
table = '<table border="1" class="dataframe">\n  <thead>\n    <tr style="text-align: right;">\n      <th>Unnamed: 0_level_0 Unnamed: 0_level_1</th>\n      <th>Year Ended December 31, 2022</th>\n      <th>Year Ended December 31, 2021</th>\n      <th>Year Ended December 31, 2020</th>\n      <th>$ Change % Change 2021</th>\n      <th>$ Change % Change to 2022</th>\n      <th>$ Change % Change 2020 to 2021</th>\n      <th>$ Change % Change 2020 to 2021.1</th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>($ millions)</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n      <td>--</td>\n    </tr>\n    <tr>\n      <td>Product costs, excluding depreciation and amortization</td>\n      <td>$ 531</td>\n      <td>$ 601</td>\n      <td>$ 615</td>\n      <td>$ (70)</td>\n      <td>(12)%$</td>\n      <td>(14)</td>\n      <td>(2)%</td>\n    </tr>\n    <tr>\n      <td>Service costs, excluding depreciation and amortization</td>\n      <td>393</td>\n      <td>383</td>\n      <td>378</td>\n      <td>10</td>\n      <td>3</td>\n      <td>5</td>\n      <td>1</td>\n    </tr>\n    <tr>\n      <td>Total costs</td>\n      <td>$ 924</td>\n      <td>$ 984</td>\n      <td>$ 993</td>\n      <td>$ (60)</td>\n      <td>(6)%$</td>\n      <td>(9)</td>\n      <td>(1)%</td>\n    </tr>\n  </tbody>\n</table>'
# table = '<table border="1" class="dataframe">\n  <thead>\n    <tr style="text-align: right;">\n      <th>(in thousands) (in thousands)</th>\n      <th>Three months ended Sep. 30, 2023</th>\n      <th>Three months ended Sep. 30, 2022</th>\n      <th>Nine months ended Sep. 30, 2023</th>\n      <th>Nine months ended Sep. 30, 2022</th>\n    </tr>\n  </thead>\n  <tbody>\n    <tr>\n      <td>Net revenue</td>\n      <td>$ 69,848</td>\n      <td>$ 78,987</td>\n      <td>$ 183,702</td>\n      <td>$ 196,518</td>\n    </tr>\n    <tr>\n      <td>Cost of sales</td>\n      <td>$ 21,586</td>\n      <td>$ 23,175</td>\n      <td>$ 54,988</td>\n      <td>$ 52,412</td>\n    </tr>\n    <tr>\n      <td>Gross profit</td>\n      <td>$ 48,262</td>\n      <td>$ 55,812</td>\n      <td>$ 128,714</td>\n      <td>$ 144,105</td>\n    </tr>\n    <tr>\n      <td>Selling, general, and administrative expenses</td>\n      <td>$ 34,489</td>\n      <td>$ 33,512</td>\n      <td>$ 97,895</td>\n      <td>$ 90,456</td>\n    </tr>\n    <tr>\n      <td>Operating income</td>\n      <td>$ 13,773</td>\n      <td>$ 22,300</td>\n      <td>$ 30,819</td>\n      <td>$ 53,650</td>\n    </tr>\n    <tr>\n      <td>Interest expense (income), net</td>\n      <td>$ 13,943</td>\n      <td>$ 9,890</td>\n      <td>$ 40,605</td>\n      <td>$ 24,045</td>\n    </tr>\n    <tr>\n      <td>Other income (expense), net</td>\n      <td>$ (573)</td>\n      <td>$ (318)</td>\n      <td>$ (1,990</td>\n      <td>$ (358)</td>\n    </tr>\n    <tr>\n      <td>Income before provision for taxes</td>\n      <td>$ (744)</td>\n      <td>$ 12,092</td>\n      <td>$ (11,776)</td>\n      <td>$ 29,247</td>\n    </tr>\n    <tr>\n      <td>Tax benefit (provision)</td>\n      <td>$ (30)</td>\n      <td>$ (21)</td>\n      <td>$ (122)</td>\n      <td>$ (262)</td>\n    </tr>\n    <tr>\n      <td>Net income</td>\n      <td>$ (774)</td>\n      <td>$ 12,071</td>\n      <td>$ (11,898)</td>\n      <td>$ 28,984</td>\n    </tr>\n  </tbody>\n</table>'

thead_content = re.search(r'<thead>(.*?)</thead>', table, re.DOTALL).group(0)
# print(thead_content)
print(table)
print("===" * 10)

if __name__ == '__main__':
    messages = [{'role': 'system', 'content': (
        f"You need to ensure this table's header is correctly written:\n{table}"
        f"\n\nOutput format:----------\nPlease output as following:\n"
        f"Chain of thought: string \ what's are your thoughts on this task and what are you doing to solve it\n"
        f"thead: string \ the new header of the table <thead>...</thead>"
    )}]

    while True:
        user_input = input("\nYou: ")  # Get user input

        # Check if user wants to quit
        if user_input.lower() in ["q", "quit", "exit"]:
            print("Exiting conversation.")
            break

        # Append user's message to the list of messages
        messages.append({"role": "user", "content": user_input})

        # Get assistant's response
        outputs = airouter.StreamedCompletion.create(
            model=f'azure_openai/{LLM.GPT_4_1106_PREVIEW}',
            temperature=0.0,
            messages=messages,
        )

        assistant_response = outputs.content
        messages.append({"role": "assistant", "content": assistant_response})

        # Print assistant's response
        print("Assistant:", assistant_response)
